Deliverect Endpoints

EnvironmentBase URLDescription
Restaurant Staginghttps://api.staging.deliverect.comFor any integration partner operating in the restaurant space and accessing endpoints in our Staging (test) Environment
Restaurant Productionhttps://api.deliverect.comFor any integration partner operating in the restaurant space and accessing endpoints in our Production (live) Environment
Retail Staginghttps://api.staging.deliverect.ioFor any integration partner operating in the retail space and accessing endpoints in our Staging (test) Environment
Retail Productionhttps://api.deliverect.ioFor any integration partner operating in the retail space and accessing endpoints in our Production (live)Environment


Restaurant POS Workflow

%%{init: {'theme': 'base', 'themeVariables': {'background': '#ffffff', 'mainBkg': '#ffffff', 'fontSize': '26px'}}}%%
sequenceDiagram
    autonumber
    actor Customer
    participant Channel as Ordering Channel
    participant Deliverect
    participant POS

    Note over Deliverect,POS: 1. Registration / Onboarding
    Note right of Deliverect: externalLocationId<br> is set in<br/>Deliverect location settings
    Deliverect->>POS: POST /register (accountId, locationId,<br/>externalLocationId, locationName)
    POS-->>Deliverect: 200 OK { ordersWebhookURL,<br/>syncProductsURL, syncTablesURL,<br/>syncFloorsURL, taxCalculationWebhookURL }
    Note right of Deliverect: Returned URLs<br>are saved<br/>in the location settings

    Note over Deliverect,POS: 2. Product Sync (user-initiated from Deliverect)
    Deliverect->>POS: GET /syncProducts?locationID=...
    alt Synchronous response
        POS-->>Deliverect: 200 OK (products & categories payload)
    else Asynchronous response
        POS-->>Deliverect: 204 No Content
        POS->>Deliverect: POST Insert/update products & categories
        Deliverect-->>POS: 200 OK
    end

    Note over Customer,POS: 3. Order Injection
    Customer->>Channel: Places an order
    Channel->>Deliverect: New order
    Deliverect->>POS: POST /orders (order webhook:<br/>items, prices, payment, customer)
    POS-->>Deliverect: 200 / 201 (within 30s)

    Note over Deliverect,POS: 4. Asynchronous Order Status Updates
    POS->>Deliverect: POST /orderStatus/{orderId} (status=ACCEPTED 20)
    Deliverect-->>POS: 200 OK
    Deliverect->>Channel: Relay status
    POS->>Deliverect: POST /orderStatus/{orderId} (status=PICKUP_READY 70)
    Deliverect-->>POS: 200 OK
    Deliverect->>Channel: Relay status
    POS->>Deliverect: POST /orderStatus/{orderId} (status=FINALIZED 90)
    Deliverect-->>POS: 200 OK

    Note over Deliverect,POS: 5. Cancellation (optional)
    Channel->>Deliverect: Cancellation request
    Deliverect->>POS: POST /orders (cancellation)
    POS->>Deliverect: POST /orderStatus/{orderId} (status=CANCELED 110)
    Deliverect-->>POS: 200 OK


Retail POS workflow


%%{init: {'theme': 'base', 'themeVariables': {'background': '#ffffff', 'mainBkg': '#ffffff', 'fontSize': '26px'}}}%%
sequenceDiagram
    participant Retail as Retail POS
    participant DR as Deliverect Retail
    participant CB as Catalog Builder
    participant CH as Retail Channels
    participant QA as Quest App

    Retail->>DR: Catalog items (Item Upload )<br> POST /catalog/accounts/{accountId}/itemsUploadUrl
    Retail->>DR: Location inventory (Inventory Update)<br> POST /catalog/accounts/{accountId}/locations/{locationId}/inventoryUpdateUrl
    DR->>CB: Build catalog
    CB->>CH: Publish catalog

    CH->>DR: Create order<br> POST /{channelName}/order/{channelLinkId}
    DR->>QA: Order sent for picking

    QA->>CH: Start picking
    QA->>CH: Picking finished

    alt Order change?
        QA->>CH: Update amendments / subs
    end

    QA->>DR: Finalized order
    DR->>Retail: Order webhook (Order Notification)
    Retail->>DR: Order status update<br> POST /orderStatus/{orderId}